import fetch from 'node-fetch';

class FetchHttp {
  async send(method, url, options) {
    const requestInit = {
      method,
      signal: options?.signal
    };
    const response = await fetch(url, requestInit);
    return {
      data: await response.json(),
      status: response.status,
      statusText: response.statusText,
      headers: response.headers.raw()
    };
  }
}

export { FetchHttp };
//# sourceMappingURL=FetchHttp.mjs.map
